## recoll 1.43.4

=== CMakeLists.txt ===
#[===========================================================================[.rst:

Recoll CMake buildsystem
------------------------

Experimental CMake build.

Since this wasn't planned to be used immediately, the version requirements are very aggressive:

Debian 12+ (Bookworm) (or equivalents)
Qt 5.15+ or Qt 6.4+
CMake 3.25+
C++11 (Qt5) or C++17 (Qt6) compiler

Configuration
^^^^^^^^^^^^^

The build can be configured, either on the command line or in the cmake-gui,
by defining the following options. (See GUI or code for defaults.)

* ``RECOLL_ENABLE_X11MON`` (default: ``OFF``)
* ``RECOLL_ENABLE_WEBENGINE`` (default: ``ON``)
* ``RECOLL_ENABLE_LIBMAGIC`` (default: ``OFF``)
* ``RECOLL_ENABLE_SYSTEMD`` (default: ``ON``, linux-only)
* ``RECOLL_QT6_BUILD`` (default: ``OFF``)

If ``RECOLL_ENABLE_SYSTEMD`` is true, the install paths can be overridden
by setting these cache variables. (Values should be paths relative to the
install prefix, e.g. ``lib/systemd/system``.)

* ``SYSTEMD_SYSTEM_UNIT_DIR``
* ``SYSTEMD_USER_UNIT_DIR``

By default, pkg-config will be used to query the paths from ``systemd.pc``.

If ``RECOLL_ENABLE_LIBMAGIC`` is false, the path to a suitable ``find``
utility must be compiled into librecoll. By default it will be discovered
in the system PATH, to override its location set ``FindProgram_EXECUTABLE``
to a suitable path.

Usage
^^^^^

cd .../recoll/src

cmake -S . -B build_dir \
      --install-prefix=/usr/local/ \
      -G Ninja \                    # or -G "Unix Makefiles"
      -DCMAKE_BUILD_TYPE=Release \
      -DRECOLL_QT6_BUILD=1 \        # for Qt6
      -DRECOLL_ENABLE_WEBENGINE=1 \ # use QtWebEngine instead of QtWebKit
      -DRECOLL_ENABLE_X11MON=1 \    # turn on X11 session monitoring
      -DFindProgram_EXECUTABLE=/opt/bin/find

# omit `-G Ninja` to use classical unix makefile as generator

cmake --build build_dir --parallel

cmake --install ./build_dir/

Toggling Options

cmake -Dsome_option=ON .....

macOS
^^^^^

To assemble a portable .app bundle, you must use the Qt from official installer.
The Homebrew Qt doesn't work, this is a known bug and unlikely to be fixed in short time.

To specify qt path, specify `CMAKE_PREFIX_PATH` when generating the build_dir

cmake -DCMAKE_PREFIX_PATH="~/Qt/6.4.2/macos" ....

 ~/Qt/6.4.2/macos/bin/macdeployqt recoll.app

To completely avoid codesign problems, just force one #TODO: use personal codesign

codesign --force --deep -s - recoll.app

#]===========================================================================]

cmake_minimum_required(VERSION 3.25)

# Load versions from text files
file(READ "RECOLL-VERSION.txt" VERSION_FILE_VERSION)
string(STRIP "${VERSION_FILE_VERSION}" VERSION_FILE_VERSION)
# Strip trailing version strings like "X.Y.ZpreN" that CMake doesn't support
string(REGEX REPLACE
    "^([0-9]+\\.[0-9]+\\.[0-9]+).*$" "\\1"
    RECOLL_VERSION "${VERSION_FILE_VERSION}"
)
file(READ "RECOLL-SOVERSION.txt" RECOLL_SOVERSION)
string(STRIP "${RECOLL_SOVERSION}" RECOLL_SOVERSION)

set(_parse_state
    "VERSION_FILE_VERSION=${VERSION_FILE_VERSION}, \
    RECOLL_VERSION=${RECOLL_VERSION}, \
    RECOLL_SOVERSION=${RECOLL_SOVERSION}")
string(LENGTH "${RECOLL_VERSION}" _rcl_ver_len)
string(LENGTH "${RECOLL_SOVERSION}" _rcl_sover_len)
if (_rcl_ver_len LESS_EQUAL 0 OR _rcl_sover_len LESS_EQUAL 0)
    message(FATAL_ERROR
        "Failed to parse version files!\nGot: ${_parse_state}")
endif()
message(DEBUG "Got: ${_parse_state}")

project(recoll
    VERSION ${RECOLL_VERSION}
    LANGUAGES CXX C)

# For our custom Find modules
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

include(GNUInstallDirs)
include(FeatureSummary)

### Configure Options

option(RECOLL_ENABLE_X11MON
    "recollindex support for X11 session monitoring (Linux only)" OFF)
option(RECOLL_ENABLE_WEBENGINE
    "Build with QtWebEngine (instead of QtWebKit)" ON)
option(RECOLL_ENABLE_LIBMAGIC
    "Enable libmagic (avoids 'file' command requirement)" OFF)
option(RECOLL_QT6_BUILD "Build using Qt6" ON)
option(RECOLL_ENABLE_SYSTEMD "Install systemd unit files (linux only)" ON)
option(RECOLL_QTGUI "Build GUI" ON)

if (RECOLL_QT6_BUILD)
    set(QT_MAJOR_VERSION 6)
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
else()
    set(QT_MAJOR_VERSION 5)
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()


# simulate autoheader
configure_file(common/autoconfig.h.cmake.in autoconfig.h @ONLY)


### Source files
set(librecoll_SOURCES
    aspell/rclaspell.cpp
    aspell/rclaspell.h
    bincimapmime/convert.cc
    bincimapmime/convert.h
    bincimapmime/mime-inputsource.h
    bincimapmime/mime-parsefull.cc
    bincimapmime/mime-parseonlyheader.cc
    bincimapmime/mime-printbody.cc
    bincimapmime/mime.cc
    bincimapmime/mime.h
    common/webstore.cpp
    common/webstore.h
    common/cjksplitter.cpp
    common/cjksplitter.h
    common/cnsplitter.cpp
    common/cnsplitter.h
    common/cstr.cpp
    common/cstr.h
    common/firstmatchline.cpp
    common/firstmatchline.h
    common/kosplitter.cpp
    common/rclconfig.cpp
    common/rclconfig.h
    common/rclinit.cpp
    common/rclinit.h
    common/rclutil.cpp
    common/rclutil.h
    common/syngroups.cpp
    common/syngroups.h
    common/textsplit.cpp
    common/textsplit.h
    common/unacpp.cpp
    common/unacpp.h
    common/uproplist.h
    index/webqueuefetcher.cpp
    index/webqueuefetcher.h
    index/checkretryfailed.cpp
    index/checkretryfailed.h
    index/exefetcher.cpp
    index/exefetcher.h
    index/fetcher.cpp
    index/fetcher.h
    index/fsfetcher.cpp
    index/fsfetcher.h
    index/idxdiags.h
    index/idxdiags.cpp
    index/idxstatus.h
    index/idxstatus.cpp
    index/mimetype.cpp
    index/mimetype.h
    index/rclmon.h
    index/recollindex.h
    index/subtreelist.cpp
    index/subtreelist.h
    internfile/Filter.h
    internfile/extrameta.cpp
    internfile/extrameta.h
    internfile/htmlparse.cpp
    internfile/htmlparse.h
    internfile/indextext.h
    internfile/internfile.cpp
    internfile/internfile.h
    internfile/mh_exec.cpp
    internfile/mh_exec.h
    internfile/mh_execm.cpp
    internfile/mh_execm.h
    internfile/mh_html.cpp
    internfile/mh_html.h
    internfile/mh_mail.cpp
    internfile/mh_mail.h
    internfile/mh_mbox.cpp
    internfile/mh_mbox.h
    internfile/mh_null.h
    internfile/mh_symlink.h
    internfile/mh_text.cpp
    internfile/mh_text.h
    internfile/mh_unknown.h
    internfile/mh_xslt.cpp
    internfile/mh_xslt.h
    internfile/mimehandler.cpp
    internfile/mimehandler.h
    internfile/myhtmlparse.cpp
    internfile/myhtmlparse.h
    internfile/txtdcode.cpp
    internfile/uncomp.cpp
    internfile/uncomp.h
    query/docseq.cpp
    query/docseq.h
    query/docseqdb.cpp
    query/docseqdb.h
    query/docseqdocs.h
    query/docseqhist.cpp
    query/docseqhist.h
    query/dynconf.cpp
    query/dynconf.h
    query/filtseq.cpp
    query/filtseq.h
    common/plaintorich.cpp
    common/plaintorich.h
    query/qresultstore.cpp
    query/qresultstore.h
    query/recollq.cpp
    query/recollq.h
    query/reslistpager.cpp
    query/reslistpager.h
    query/sortseq.cpp
    query/sortseq.h
    query/wasaparse.cpp # generated via wasaparse.ypp
    query/wasaparseaux.cpp
    query/wasaparserdriver.h
    query/wasatorcl.h
    rcldb/daterange.cpp
    rcldb/daterange.h
    rcldb/expansiondbs.cpp
    rcldb/expansiondbs.h
    rcldb/rclabstract.cpp
    rcldb/rclabsfromtext.cpp
    rcldb/rcldb.cpp
    rcldb/rclndb.cpp
    rcldb/rcldb.h
    rcldb/rcldb_p.h
    rcldb/rcldoc.cpp
    rcldb/rcldoc.h
    rcldb/rcldups.cpp
    rcldb/rclquery.cpp
    rcldb/rclquery.h
    rcldb/rclquery_p.h
    rcldb/rclterms.cpp
    rcldb/rclvalues.cpp
    rcldb/rclvalues.h
    rcldb/searchdata.cpp
    rcldb/searchdata.h
    rcldb/searchdatatox.cpp
    rcldb/searchdataxml.cpp
    rcldb/stemdb.cpp
    rcldb/stemdb.h
    rcldb/stoplist.cpp
    rcldb/stoplist.h
    rcldb/synfamily.cpp
    rcldb/synfamily.h
    rcldb/termproc.h
    rcldb/xmacros.h
    unac/unac.cpp
    unac/unac.h
    unac/unac_version.h
    utils/appformime.cpp
    utils/appformime.h
    utils/base64.cpp
    utils/base64.h
    utils/cancelcheck.cpp
    utils/cancelcheck.h
    utils/chrono.h
    utils/chrono.cpp
    utils/circache.cpp
    utils/circache.h
    utils/closefrom.cpp
    utils/closefrom.h
    utils/cmdtalk.cpp
    utils/cmdtalk.h
    utils/conftree.cpp
    utils/conftree.h
    utils/copyfile.cpp
    utils/copyfile.h
    utils/cpuconf.cpp
    utils/cpuconf.h
    utils/damlev.h
    utils/ecrontab.cpp
    utils/ecrontab.h
    utils/execmd.cpp
    utils/execmd.h
    utils/fileudi.cpp
    utils/fileudi.h
    utils/fstreewalk.cpp
    utils/fstreewalk.h
    utils/hldata.h
    utils/hldata.cpp
    utils/idfile.cpp
    utils/idfile.h
    utils/listmem.cpp
    utils/listmem.h
    utils/log.cpp
    utils/log.h
    utils/md5.cpp
    utils/md5.h
    utils/md5ut.cpp
    utils/md5ut.h
    utils/mimeparse.cpp
    utils/mimeparse.h
    utils/miniz.cpp
    utils/miniz.h
    utils/netcon.cpp
    utils/netcon.h
    utils/pathut.cpp
    utils/pathut.h
    utils/picoxml.h
    utils/pxattr.cpp
    utils/pxattr.h
    utils/rclionice.cpp
    utils/rclionice.h
    utils/readfile.cpp
    utils/readfile.h
    utils/smallut.cpp
    utils/smallut.h
    utils/strmatcher.cpp
    utils/strmatcher.h
    utils/transcode.cpp
    utils/transcode.h
    utils/utf8iter.cpp
    utils/utf8iter.h
    utils/wipedir.cpp
    utils/wipedir.h
    utils/workqueue.h
    utils/x11mon.cpp
    utils/x11mon.h
    utils/zlibut.cpp
    utils/zlibut.h
    xaposix/safeunistd.h
    )

set(recollindex_SOURCES
    index/checkindexed.cpp
    index/checkindexed.h
    index/fsindexer.cpp
    index/fsindexer.h
    index/indexer.cpp
    index/indexer.h
    index/rclmonprc.cpp
    index/rclmonrcv.cpp
    index/recollindex.cpp
    index/webqueue.cpp
    index/webqueue.h
    )

set(recollq_SOURCE
    query/recollqmain.cpp
    query/recollq.cpp
    query/recollq.h)


set(example_config_files
    sampleconf/fields
    sampleconf/fragment-buttons.xml
    sampleconf/mimeconf
    sampleconf/mimemap
    sampleconf/mimeview
    sampleconf/recoll-common.css
    sampleconf/recoll-common.qss
    sampleconf/recoll-dark.css
    sampleconf/recoll-dark.qss
    sampleconf/recoll.conf
    sampleconf/recoll.qss
    )

set(filter_files
    python/recoll/recoll/rclconfig.py
    python/recoll/recoll/conftree.py
    filters/abiword.xsl
    filters/cmdtalk.py
    filters/fb2.xsl
    filters/gnumeric.xsl
    filters/kosplitter.py
    filters/msodump.zip
    filters/okular-note.xsl
    filters/opendoc-body.xsl
    filters/opendoc-flat.xsl
    filters/opendoc-meta.xsl
    filters/openxml-meta.xsl
    filters/openxml-word-body.xsl
    filters/openxml-xls-body.xsl
    filters/ppt-dump.py
    filters/rcl7z.py
    filters/rclaptosidman
    filters/rclaspell-sugg.py
    filters/rclaudio.py
    filters/rclbasehandler.py
    filters/rclbibtex.sh
    filters/rclcheckneedretry.sh
    filters/rclchm.py
    filters/rcldia.py
    filters/rcldjvu.py
    filters/rcldoc.py
    filters/rcldvi
    filters/rclepub.py
    filters/rclepub1.py
    filters/rclexec1.py
    filters/rclexecm.py
    filters/rclfb2.py
    filters/rclgaim
    filters/rclgenxslt.py
    filters/rclhwp.py
    filters/rclics.py
    filters/rclimg
    filters/rclimg.py
    filters/rclinfo.py
    filters/rclipynb.py
    filters/rclkar.py
    filters/rclkwd
    filters/rcllatinclass.py
    filters/rcllatinstops.zip
    filters/rcllyx
    filters/rclman
    filters/rclmidi.py
    filters/rclocr.py
    filters/rclocrabbyy.py
    filters/rclocrcache.py
    filters/rclocrtesseract.py
    filters/rclopxml.py
    filters/rclorgmode.py
    filters/rclpages.py
    filters/rclpdf.py
    filters/rclppt.py
    filters/rclps
    filters/rclpst.py
    filters/rclpurple
    filters/rclpython.py
    filters/rclrar.py
    filters/rclrtf.py
    filters/rclscribus
    filters/rclshowinfo
    filters/rcltar.py
    filters/rcltex

=== qtgui/CMakeLists.txt ===
# qtgui related

set(qtgui_ui_SOURCES
    actsearch.ui
    advsearch.ui
    configswitch.ui
    crontool.ui
    firstidx.ui
    idxsched.ui
    preview.ui
    ptrans.ui
    rclmain.ui
    restable.ui
    rtitool.ui
    snippets.ui
    specialindex.ui
    spell.ui
    ssearchb.ui
    uiprefs.ui
    viewaction.ui
    webcache.ui
    widgets/editdialog.ui
    widgets/listdialog.ui
    winschedtool.ui
    )

set(qtgui_SOURCES
    actsearch_w.cpp
    actsearch_w.h
    advsearch_w.cpp
    advsearch_w.h
    advshist.cpp
    advshist.h
    confgui/confgui.cpp
    confgui/confgui.h
    confgui/confguiindex.cpp
    confgui/confguiindex.h
    configswitch.cpp
    configswitch.h
    crontool.cpp
    crontool.h
    firstidx.h
    fragbuts.cpp
    fragbuts.h
    guiutils.cpp
    guiutils.h
    idxmodel.cpp
    idxmodel.h
    idxsched.h
    main.cpp
    multisave.cpp
    multisave.h
    preview_load.cpp
    preview_load.h
    preview_plaintorich.cpp
    preview_plaintorich.h
    preview_w.cpp
    preview_w.h
    ptrans_w.cpp
    ptrans_w.h
    rclhelp.cpp
    rclhelp.h
    rclm_idx.cpp
    rclm_menus.cpp
    rclm_preview.cpp
    rclm_saveload.cpp
    rclm_sidefilters.cpp
    rclm_view.cpp
    rclm_wins.cpp
    rclmain_w.cpp
    rclmain_w.h
    rclwebpage.h
    rclzg.cpp
    rclzg.h
    recoll.h
    reslist.cpp
    reslist.h
    respopup.cpp
    respopup.h
    restable.cpp
    restable.h
    rtitool.cpp
    rtitool.h
    scbase.cpp
    scbase.h
    searchclause_w.cpp
    searchclause_w.h
    snippets_w.cpp
    snippets_w.h
    specialindex.h
    spell_w.cpp
    spell_w.h
    ssearch_w.cpp
    ssearch_w.h
    systray.cpp
    systray.h
    uiprefs_w.cpp
    uiprefs_w.h
    viewaction_w.cpp
    viewaction_w.h
    webcache.cpp
    webcache.h
    widgets/editdialog.h
    widgets/listdialog.h
    widgets/qxtconfirmationmessage.cpp
    widgets/qxtconfirmationmessage.h
    widgets/qxtglobal.h
    xmltosd.cpp
    xmltosd.h
    )


#--- recoll ---

find_package(Qt${QT_MAJOR_VERSION} COMPONENTS Core)
if (NOT Qt${QT_MAJOR_VERSION}_FOUND)
     message(FATAL_ERROR "Could not find Qt version ${QT_MAJOR_VERSION}!")
endif()

if (QT_MAJOR_VERSION GREATER 5)
    qt_standard_project_setup()
endif()
set(CMAKE_AUTOMOC TRUE)
set(CMAKE_AUTOUIC TRUE)
set(CMAKE_AUTORCC TRUE)

add_executable(recoll
    ${qtgui_SOURCES}
    ${qtgui_ui_SOURCES}
    recoll.qrc
)

set_target_properties(recoll PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}
    INSTALL_RPATH "$ORIGIN/../${CMAKE_INSTALL_LIBDIR}/recoll"
    MACOSX_BUNDLE TRUE
    MACOSX_BUNDLE_GUI_IDENTIFIER org.lesbonscomptes.recoll
    MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
    MACOSX_BUNDLE_SHORT_VERSION_STRING
        "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
    MACOSX_BUNDLE_ICON_FILE recoll.icns
)
target_compile_definitions(recoll PRIVATE BUILDING_RECOLLGUI)

set(QtComponents Core Gui Widgets PrintSupport)

if (RECOLL_ENABLE_WEBENGINE)
    list(APPEND QtComponents WebEngineWidgets)
    target_compile_definitions(recoll PUBLIC USING_WEBENGINE)
else()
    list(APPEND QtComponents WebKitWidgets)
    target_compile_definitions(recoll PUBLIC USING_WEBKIT)
endif ()

find_package(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS ${QtComponents})

list(TRANSFORM QtComponents
    PREPEND "Qt${QT_MAJOR_VERSION}::"
    OUTPUT_VARIABLE _qt_targets)
target_link_libraries(recoll PUBLIC ${_qt_targets})
unset(_qt_targets)

target_include_directories(recoll PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    widgets
    ../query
    )

target_link_libraries(recoll PRIVATE librecoll)

if (QT_MAJOR_VERSION GREATER 5)
    qt_finalize_target(recoll)
endif()

### Special handling of translation files

find_package(Qt${QT_MAJOR_VERSION} COMPONENTS LinguistTools)

# include all *.ts files under locale
file(GLOB TRANS_FILES "qtgui/i18n/*.ts")

# Put generated *.qm to output dir's locale
set_source_files_properties(${TRANS_FILES} PROPERTIES
    OUTPUT_LOCATION "${PROJECT_BINARY_DIR}/i18n")

# Do *.ts -> *.qm during the target `recoll` and store result files to ${QM_FILES}
qt_add_translation(QM_FILES ${TRANS_FILES})

target_sources(recoll PRIVATE ${QM_FILES})

=== doc/user/Makefile ===



# Wherever docbook.xsl and chunk.xsl live.
# NOTE: THIS IS HARDCODED inside custom.xsl (for changing the output
# charset), which needs to change if the stylesheet location changes.
# Necessity of custom.xsl:
#   http://www.sagehill.net/docbookxsl/OutputEncoding.html

# Fbsd
#XSLDIR="/usr/local/share/xsl/docbook/"
# Mac
#XSLDIR="/opt/local/share/xsl/docbook-xsl/"
#Linux
XSLDIR="/usr/share/xml/docbook/stylesheet/docbook-xsl/"

# Note: this is where I find the confxml utility at home. The source is in src/utils, you can build
# it with:
#    c++ -std=c++17 -I. confxml.cpp -o confxml -lrecoll
UTILBUILDS=/home/dockes/tmp/builds/medocutils/

HTMLDUMPER = lynx -dump

# Options common to the single-file and chunked versions
commonoptions=--stringparam section.autolabel 1 \
  --stringparam section.autolabel.max.depth 2 \
  --stringparam section.label.includes.component.label 1 \
  --stringparam toc.max.depth 4 \
  --stringparam toc.section.depth 3 \
  --stringparam autotoc.label.in.hyperlink 0 \
  --stringparam abstract.notitle.enabled 1 \
  --stringparam html.stylesheet docbook-xsl.css \
  --stringparam generate.toc "book toc,title,figure,table,example,equation"


# index.html chunk format target replaced by nicer webhelp (needs separate make) in webhelp/ subdir
all: usermanual.html webh usermanual.pdf

webh:
	make -C webhelp
        
usermanual.html: usermanual.xml recoll.conf.xml
	xsltproc --xinclude ${commonoptions} -o tmpfile.html custom.xsl $<
	-tidy -indent tmpfile.html > usermanual.html
	rm -f tmpfile.html
	-$(HTMLDUMPER) usermanual.html > ../../README
        
index.html: usermanual.xml recoll.conf.xml
	xsltproc ${commonoptions} \
            --stringparam use.id.as.filename 1 \
            --stringparam root.filename index \
            "${XSLDIR}/html/chunk.xsl" $<

usermanual.pdf: usermanual.xml recoll.conf.xml
	dblatex --xslt-opts="--xinclude" -tpdf $<

recoll.conf.xml: ../../sampleconf/recoll.conf
	test -x $(UTILBUILDS)/confxml && $(UTILBUILDS)/confxml --docbook --sectlevel=1 \
        --idprefix=RCL.CONFIG.RECOLLCONF  \
        ../../sampleconf/recoll.conf  > recoll.conf.xml || touch recoll.conf.xml

# Generating a restructured text version, for uploading to readthedocs.
# Does not really work, the internal links are botched. pandoc
# generates something like:
#  `configuration <#RCL.INDEXING.CONFIG>`__
# when it should be:
# :ref:`RCL.INDEXING.CONFIG`
# Also with the second form, the link text is the section heading (can't be
# chosen), which is not nice. Else, the change could probably be done by a
# script. 
# Also could not get readthedocs to generate the left pane TOC? could
# probably be fixed...
#usermanual-rst: recoll.conf.xml
#	tail -n +2 recoll.conf.xml > rcl-conf-tail.xml
#	sed -e '/xi:include/r rcl-conf-tail.xml' \
#		< usermanual.xml > full-man.xml
#	sed -i -e '/xi:include/d' -e '/<?xml version="1.0"?>/d' full-man.xml
#	pandoc -s -f docbook -t rst full-man.xml  > \
#		../../../docs/index.rst
#	rm -f rcl-conf-tail.xml full-man.xml
# not needed with pandoc 2.x -@echo fix termmatch and execute

clean:
	rm -f RCL.*.html usermanual.pdf usermanual.html index.html \
	  tmpfile.html rcl-conf-tail.xml full-man.xml

=== kde/krunner/CMakeLists.txt ===
# KF5 version of the recoll krunner module.
# Create from https://develop.kde.org/docs/extend/plasma/krunner/ as example
# Dependancies:
#  ki18n-devel plasma-framework-devel kconfig-devel kpackage-devel
#  krunner-devel knotifications-devel

cmake_minimum_required(VERSION 3.16)
project(recollrunner)

option(RECOLL_PUBLIC_LIB "Does nothing, kept for compat" 1)

set(KF5_MIN_VERSION "5.0")
set(CMAKE_SKIP_RPATH TRUE)

# Include the Extra-CMake-Modules project
find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR} ${CMAKE_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(FeatureSummary)

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS I18n Config Runner KIO Notifications Config)

## Recoll stuff
set(rcltop ${CMAKE_CURRENT_SOURCE_DIR}/../../)

add_definitions(
    -DRECOLL_DATADIR="${CMAKE_INSTALL_PREFIX}/share/recoll"
    -DLIBDIR="${CMAKE_INSTALL_PREFIX}/lib"
)


include_directories (
  ${CMAKE_SOURCE_DIR}
  ${rcltop}/common 
  ${rcltop}/internfile 
  ${rcltop}/query 
  ${rcltop}/rcldb 
  ${rcltop}/utils 
  ${rcltop}/redhat-linux-build
)

include_directories (
    ${CMAKE_INSTALL_PREFIX}/include/recoll
)

# Check if running inside a build tree, then use the not yet installed lib.
foreach(libdir IN ITEMS  ${CMAKE_BINARY_DIR}/../../.libs
                         ${CMAKE_BINARY_DIR}/../../../.libs
                         ${CMAKE_BINARY_DIR}/../../../../.libs
                         ${CMAKE_BINARY_DIR}/../../../redhat-linux-build
                         $ENV{RECOLL_LIB_DIR}/
                         )
    message(STATUS "TESTING link directory ${libdir}")
    if (EXISTS ${libdir}/librecoll.so)
        message(STATUS "USING link directory ${libdir}")
        link_directories(${CMAKE_INSTALL_PREFIX}/lib ${libdir})
    endif()
endforeach()

kcoreaddons_add_plugin(krunner_recoll SOURCES recollrunner.cpp INSTALL_NAMESPACE "kf5/krunner")

set_property(TARGET krunner_recoll PROPERTY CXX_STANDARD 14)

target_link_libraries(krunner_recoll
    KF5::I18n
    KF5::ConfigCore
    KF5::Runner
    KF5::KIOWidgets
    KF5::Notifications
    recoll
    xapian
    xslt
    xml2
    X11
    dl
    z
    pthread
)

=== python/samples/recollgui/Makefile ===
PYUIC = pyuic5
all: rclmain.py

rclmain.py: rclmain.ui
	$(PYUIC) -o rclmain.py rclmain.ui

clean:
	rm -f rclmain.py rclmain.pyc

=== debian/changelog ===
recoll (1.43.4-1) unstable; urgency=low

  [ Kartik Mistry ]
  * New upstream release.
  * debian/copyright:
    + Fixed old FSF address.

  [ Tmanok ]
  * Replace orphaned untex with texlive-binaries in Suggests
    - untex has been orphaned for ~6.5 years
    - recoll already prefers detex (provided by texlive-binaries)
    - Keep wv temporarily until upstream implements soffice fallback

 -- Kartik Mistry <kartik@debian.org>  Wed, 20 Aug 2025 13:17:01 +0530

=== debian/control ===
Source: recoll
Section: x11
Priority: optional
Maintainer: Kartik Mistry <kartik@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               bison,
               libaspell-dev,
               libchm-dev,
               libmagic-dev,
               libx11-dev,
               libxapian-dev,
               libxslt1-dev,
               libz-dev,
               meson,
               ninja-build,
               pkgconf,
               python3-all,
               python3-all-dev,
               python3-setuptools,
               qt6-base-dev,
               qt6-l10n-tools,
               qt6-webengine-dev
Vcs-Git: https://salsa.debian.org/debian/recoll.git
Vcs-Browser: https://salsa.debian.org/debian/recoll
Homepage: https://www.recoll.org
Standards-Version: 4.7.2
Rules-Requires-Root: no

Package: recoll
Architecture: all
Depends: recollcmd, recollgui, ${misc:Depends}
Description: Personal full text search package
 This package is a personal full text search package is based on a very strong
 backend (Xapian), for which it provides an easy to use and feature-rich
 interface.
 .
 Features:
  * Qt-based GUI.
  * Supports the following document types (and their compressed versions).
   - Natively: text, html, OpenOffice files, maildir and mailbox (Mozilla and
     IceDove mail) with attachments, pidgin log files.
   - With external helpers:  pdf (pdftotext), postscript (ghostscript), msword
     (antiword), excel, rtf (unrtf).
  * Powerful query facilities, with boolean searches, phrases, filter on file
    types and directory tree.
  * Support for multiple charsets, Internal processing and storage uses Unicode
    UTF-8.
  * Stemming performed at query time (can switch stemming language after
    indexing).
  * Easy installation. No database daemon, web server or exotic language
    necessary.
  * An indexer which runs either as a thread inside the GUI or as an external,
    cron'able program.
 .
 This metapackage installs recoll GUI and commandline tools.

Package: recollcmd
Architecture: any
Breaks: recollgui (<< 1.28.5-1)
Replaces: recollgui (<< 1.28.5-1)
Depends: librecoll39 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: aspell, python3, python3-recoll, xdg-utils, xsltproc
Suggests: antiword,
          djvulibre-bin,
          ghostscript,
          groff,
          libimage-exiftool-perl,
          libinotifytools0,
          libwpd-tools,
          poppler-utils,
          pstotext,
          python3-chardet,
          python3-chm,
          python3-icalendar,
          python3-lxml,
          python3-mido,
          python3-mutagen,
          python3-py7zr,
          python3-rarfile,
          texlive-binaries,
          unrtf,
          wv
Description: Command line programs for recoll
 This package contains command line programs for a personal full text search
 package recoll.

Package: recollgui
Architecture: any
Breaks: recollcmd (<< 1.28.5-1)
Replaces: recollcmd (<< 1.28.5-1)
Depends: recollcmd (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: GUI program and elements for recoll
 This package contains main recoll GUI for configuring, controlling and
 querying recoll indexes.

Package: python3-recoll
Architecture: any
Section: python
Depends: librecoll39 (= ${binary:Version}),
         python3,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python extension for recoll (Python3)
 Personal full text search package which is based on a very strong backend
 (Xapian), for which it provides an easy to use and feature-rich interface.
 .
 This package provides Python3 extension module for recoll which can be use to
 extend recoll such as an Ubuntu Unity Lens.

Package: librecoll39
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: recollcmd (<< 1.36.1-1)
Multi-Arch: same
Description: Base library for recoll and related extensions
 This package contains the base code interfacing with Xapian and is used by the
 recoll commands, the Python extensions, the KDE plugins.

Package: librecoll39-dev
Architecture: any
Section: libdevel
Depends: librecoll39 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Development files for librecoll
 This package  contains the development files for librecoll package, which is
 base code interfacing with Xapian and is used by the recoll commands, the
 Python extensions, the KDE plugins.

## recoll 1.43.7

=== debian/changelog ===
recoll (1.43.7-1) unstable; urgency=medium

  * New upstream release:
    + Fix singleapplication code and license (Closes: #1117639)
  * debian/control:
    + Removed 'Rules-Requires-Root' field.
  * Updated debian/watch to standard 5.

 -- Kartik Mistry <kartik@debian.org>  Mon, 24 Nov 2025 14:02:13 +0530

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,6 @@
 Vcs-Browser: https://salsa.debian.org/debian/recoll
 Homepage: https://www.recoll.org
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 
 Package: recoll
 Architecture: all

## recoll 1.43.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -293,6 +293,8 @@
     utils/appformime.h
     utils/base64.cpp
     utils/base64.h
+    utils/boolexp.cpp
+    utils/boolexp.h
     utils/cancelcheck.cpp
     utils/cancelcheck.h
     utils/chrono.h
@@ -411,6 +413,8 @@
     filters/opendoc-flat.xsl
     filters/opendoc-meta.xsl
     filters/openxml-meta.xsl
+    filters/openxml-ppt-body.xsl
+    filters/openxml-visio-body.xsl
     filters/openxml-word-body.xsl
     filters/openxml-xls-body.xsl
     filters/ppt-dump.py
@@ -460,8 +464,3 @@
     filters/rclpurple
     filters/rclpython.py
     filters/rclrar.py
-    filters/rclrtf.py
-    filters/rclscribus
-    filters/rclshowinfo
-    filters/rcltar.py
-    filters/rcltex

=== meson_options.txt ===
option('testmains', type: 'boolean', value: false,
       description: 'Build small diag/test drivers. Not unit tests')
option('rclgrep', type: 'boolean', value: false,
       description: 'Build the index-less search tool')
option('python-module', type: 'boolean', value: true,
       description: 'Build the Recoll Python extension module.')
option('python-chm', type: 'boolean', value: true,
       description: 'Build the libchm Python wrapper')
option('python-aspell', type: 'boolean', value: true,
       description: 'build the aspell Python wrapper')
option('indexer', type: 'boolean', value: true,
       description: 'Build the recollindex indexer (else recoll is query-only)')
option('xadump', type: 'boolean', value: false,
       description: 'build the xadump low level Xapian access program')
option('recollq', type: 'boolean', value: false,
       description: 'Build the recollq command line query tool')
option('qtgui', type: 'boolean', value: true,
       description: 'Build the Qt GUI')
option('noqtsingleapp', type: 'boolean', value: false,
       description: 'Do not use Use the SingleApplication module')
option('webkit', type: 'boolean', value: true,
       description: 'Use Qt Webkit')
option('webengine', type: 'boolean', value: false,
       description: 'Use Qt Webengine instead of Webkit')
option('webpreview', type: 'boolean', value: true,
       description: 'Implement the GUI preview windows with webkit or webengine instead of qtextbrowser')
option('guidebug', type: 'boolean', value: false,
       description: 'Generate and retain debug symbols in the GUI program')
# Note: idxthreads should have a false default on Mac OS as it does not perform well.
option('idxthreads', type: 'boolean', value : true,
       description: 'Enable multithreaded indexing')
option('simdutf', type: 'boolean', value : true,
       description: 'Use the simdutf module for faster charset conversion')
option('spawn', type: 'boolean', value : false,
       description: 'Use posix_spawn instead of execv')
option('camelcase', type: 'boolean', value : false,
       description: 'Split camelCase words. This has bad consequences for phrase searches')
option('libmagic', type: 'boolean', value: true,
       description: 'Use libmagic instead of executing xdg-mime/file')
option('ext4-birthtime', type: 'boolean', value: false,
       description: 'Support birthtime metadata for ext4 file systems')
option('x11mon', type: 'boolean', value: true,
       description: 'recollindex support for X11 session monitoring (needs Xlib)')
option('file-command', type: 'string', value: 'file',
       description: 'file type identification command to use by default. This is normally defined in the config')
option('aspell', type: 'boolean', value: true,
       description: 'Use the aspell program and/or library for spelling approximations')
option('inotify', type: 'boolean', value: true,
       description: 'Use inotify for monitoring file changes')
option('fam', type: 'boolean', value: false,
       description: 'Use fam for monitoring file changes')
option('fsevents', type: 'boolean', value: true,
       description: 'Use Apple fsevents API for monitoring file changes')
option('qtzeitgeist', type: 'boolean', value: false,
       description: 'Use the qt zeitgeist library for generating zeitgeist events')
option('appimage', type: 'boolean', value: false,
       description: 'build for inclusion in an AppImage')
option('catch', type: 'boolean', value: false, description: 'build the catch2 unit tests')
option('systemd', type: 'boolean', value: true,
       description: 'Install the systemd unit files')
# Was supplied in configure.ac 'pkg-config --variable systemd_system_unit_dir systemd'
option('systemd-system-unit-dir', type: 'string', value:'/usr/lib/systemd/system',
       description: 'Install location for systemd system unit files')
# Was supplied in configure.ac by 'pkg-config --variable systemd_user_unit_dir systemd'
option('systemd-user-unit-dir', type: 'string', value:'/usr/lib/systemd/user',
       description: 'Install location for systemd user unit files')
# Note: the autotools build never built the manual, and the build would not work for out of tree
# builds anyway.  the tar-based build succeeded because usermanual.html was part of the tarfile
# Not sure it makes sense to fix this.
#option('userdoc', type: 'boolean', value: true,
#       description: 'Build the user manual (needs docbook xml/xsl files and TeX tools)')
option('aspell_include_dir', type: 'string', value:'',
                             description: 'Specify the aspell include directory (if not found in the system include directories).')
option('chm_include_dir', type: 'string', value:'',
                          description: 'Specify the chm include directory (if not found in the system include directories).')

=== debian/changelog ===
recoll (1.43.9-1) unstable; urgency=low

  * New upstream release.
  * Registered recoll user manual using doc-base.
  * Removed very old README.Debian. Versions mentioned are not even in the
    oldoldstable.

 -- Kartik Mistry <kartik@debian.org>  Sun, 28 Dec 2025 12:26:17 +0530

=== debian/watch ===
Version: 5

Source: https://www.recoll.org/pages/download.html
Matching-Pattern: (?:|.*/)recoll(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
Pgpmode: auto

## recoll 1.43.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -241,6 +241,8 @@
     query/dynconf.h
     query/filtseq.cpp
     query/filtseq.h
+    query/hldata.h
+    query/hldata.cpp
     common/plaintorich.cpp
     common/plaintorich.h
     query/qresultstore.cpp
@@ -320,8 +322,6 @@
     utils/fileudi.h
     utils/fstreewalk.cpp
     utils/fstreewalk.h
-    utils/hldata.h
-    utils/hldata.cpp
     utils/idfile.cpp
     utils/idfile.h
     utils/listmem.cpp

=== meson_options.txt ===
--- 
+++ 
@@ -45,6 +45,8 @@
        description: 'file type identification command to use by default. This is normally defined in the config')
 option('aspell', type: 'boolean', value: true,
        description: 'Use the aspell program and/or library for spelling approximations')
+option('semantic', type: 'boolean', value: false,
+       description: 'Enable the semantic search functions')
 option('inotify', type: 'boolean', value: true,
        description: 'Use inotify for monitoring file changes')
 option('fam', type: 'boolean', value: false,

=== debian/changelog ===
recoll (1.43.12-1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- John Goerzen <jgoerzen@complete.org>  Thu, 26 Feb 2026 03:19:36 +0000

recoll (1.43.12-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    + Removed 'Priority' field.
    + Updated Standards-Version to 4.7.3
  * Use proper short license for CC0-1.0

 -- Kartik Mistry <kartik@debian.org>  Sat, 24 Jan 2026 18:16:48 +0530

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: recoll
 Section: x11
-Priority: optional
 Maintainer: Kartik Mistry <kartik@debian.org>
 Build-Depends: debhelper-compat (= 13),
                dh-python,
@@ -24,7 +23,7 @@
 Vcs-Git: https://salsa.debian.org/debian/recoll.git
 Vcs-Browser: https://salsa.debian.org/debian/recoll
 Homepage: https://www.recoll.org
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 
 Package: recoll
 Architecture: all
